library aursir_polymer.import;

import 'package:polymer/polymer.dart';
import 'dart:convert';
import 'dart:async';
import 'package:yaml/yaml.dart';
import 'package:aursir4dart/imported_appkey.dart';
import 'package:aursir4dart/interface.dart';

@CustomTag('aursir-polymer-import')
class AursirImportElement extends PolymerElement {
    @published AurSirImport asimport;

    @published bool exported;

    @published String appkey;
    @published String appkey_yaml;
    @published List<String> tags = [];

    @observable AurSirInterface interface;

    Future callFunction(String FunctionName, [Map Parameter]) => asimport.callFunction(FunctionName,Parameter);
    triggerFunction(String FunctionName, [Map Parameter]) => asimport.triggerFunction(FunctionName,Parameter);

    AursirImportElement.created(): super.created();

    void detached() => asimport.remove();

    void onDocked(){
      Map parsedKey;
      if (appkey_yaml != "") parsedKey = loadYaml(appkey_yaml);
      else parsedKey = JSON.decode(appkey);

      interface.addImport(parsedKey,tags).then((AurSirImport i) {
        asimport = i;
        i.exported_stream.listen((bool e) {
          exported = e;
          new Timer(new Duration(milliseconds:1), () => fire("export-state-change"));

        });
        new Timer(new Duration(milliseconds:1), () => fire("import-ready"));

      });
    }
}
